    //+------------------------------------------------------------------+
    //| smoothed rsi |
    //| mladen |
    //+------------------------------------------------------------------+
    #property copyright "www.forex-tsd.com"
    #property link "www.forex-tsd.com"

    #property indicator_separate_window
    #property indicator_buffers 3
    #property indicator_color1 Gray
    #property indicator_color2 LimeGreen
    #property indicator_color3 Orange
    #property indicator_width2 2
    #property indicator_width3 2
    #property indicator_minimum 0
    #property indicator_maximum 1

    //
    //
    //
    //
    //

    extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;
    extern int                Length       = 14;
    extern ENUM_APPLIED_PRICE Price        = PRICE_CLOSE;
    extern double             LevelUp      = 70;
    extern double             LevelDown    = 30;
    extern double             SmoothLength = 20;
    //
    //
    //
    //
    //

    double rsi[];
    double histou[];
    double histod[];
    double histon[];
    double prc[];
    double trend[];
    string indicatorFileName;
    bool   returnBars;

    //+------------------------------------------------------------------+
    //| |
    //+------------------------------------------------------------------+
    //
    //
    //
    //
    //

    int init()
    {
    IndicatorBuffers(6);
    SetIndexBuffer(0,histon);SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(1,histou);SetIndexStyle(1,DRAW_HISTOGRAM);
    SetIndexBuffer(2,histod);SetIndexStyle(2,DRAW_HISTOGRAM);
    SetIndexBuffer(3,rsi);
    SetIndexBuffer(4,prc);
    SetIndexBuffer(5,trend);
       Length = MathMax(Length ,1);
       string PriceType;
         switch(Price)
         {
            case PRICE_CLOSE:    PriceType = "Close";    break; // 0
            case PRICE_OPEN:     PriceType = "Open";     break; // 1
            case PRICE_HIGH:     PriceType = "High";     break; // 2
            case PRICE_LOW:      PriceType = "Low";      break; // 3
            case PRICE_MEDIAN:   PriceType = "Median";   break; // 4
            case PRICE_TYPICAL:  PriceType = "Typical";  break; // 5
            case PRICE_WEIGHTED: PriceType = "Weighted"; break; // 6
         }

    //
    //
    //
    //
    //

    SetLevelValue(0,LevelUp);
    SetLevelValue(1,LevelDown);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
    string addName = "";
       if (SmoothLength>1) addName = "smoothed ";
       IndicatorShortName(timeFrameToString(TimeFrame)+" RSI "+addName+"("+Length+","+PriceType+")");
    return(0);
    }


    int deinit()
    {
    return(0);
    }

    //+------------------------------------------------------------------+
    //| |
    //+------------------------------------------------------------------+
    //
    //
    //
    //
    //

    int start()
    {
      int counted_bars=IndicatorCounted();
         if(counted_bars<0) return(-1);
         if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { histon[0] = limit+1; return(0); }
            if (TimeFrame!=_Period)
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     histon[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,LevelUp,LevelDown,SmoothLength,0,y);
                     histou[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,LevelUp,LevelDown,SmoothLength,1,y);
                     histod[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,LevelUp,LevelDown,SmoothLength,2,y);
               }
               return(0);
            }               

    //
    //
    //
    //
    //
    //

    for(i=limit; i >= 0; i--) prc[i] = iSsm(iMA(NULL,0,1,0,MODE_SMA,Price,i),SmoothLength,i);
    for(i=limit; i >= 0; i--)
    {
       rsi[i] = iRSIOnArray(prc,0,Length,i);
       histon[i] = EMPTY_VALUE;
       histou[i] = EMPTY_VALUE;
       histod[i] = EMPTY_VALUE;

      //
      //
      //
      //
      //

      trend[i] = trend[i+1];
      if (rsi[i]>LevelUp)                     trend[i]= 1;
      if (rsi[i]<LevelDown)                   trend[i]=-1;
      if (rsi[i]<LevelUp && rsi[i]>LevelDown) trend[i]= 0;
         if (trend[i] ==  1) histou[i] = 1;
         if (trend[i] == -1) histod[i] = 1;
         if (trend[i] ==  0) histon[i] = 1;
    }
    return(0);
}



    //------------------------------------------------------------------
    //
    //------------------------------------------------------------------
    //
    //
    //
    //
    //

    double workSsm[][2];
    #define _price 0
    #define _ssm 1

    double workSsmCoeffs[][4];
    #define _period 0
    #define _c1 1
    #define _c2 2
    #define _c3 3
    #define Pi 3.14159265358979323846264338327950288

    //
    //
    //
    //
    //

    double iSsm(double price, double period, int i, int instanceNo=0)
    {
    if (period<=1) return(price);
    if (ArrayRange(workSsm,0) !=Bars) ArrayResize(workSsm,Bars);
    if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
    if (workSsmCoeffs[instanceNo][_period] != period)
    {
    workSsmCoeffs[instanceNo][_period] = period;
    double a1 = MathExp(-1.414*Pi/period);
    double b1 = 2.0*a1*MathCos(1.414*Pi/period);
    workSsmCoeffs[instanceNo][_c2] = b1;
    workSsmCoeffs[instanceNo][_c3] = -a1*a1;
    workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
    }

    //
    //
    //
    //
    //

    i = Bars-i-1;
    int s = instanceNo*2;
    workSsm[i][s+_price] = price;
    workSsm[i][s+_ssm] = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 +
    workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm] +
    workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
    return(workSsm[i][s+_ssm]);
    } 

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
